#pragma once

#define DEF_ITEM_FONT_HEIGHT		(9)
#define DEF_ITEM_FONT_STYLE			(FontStyleRegular)
#define DEF_ITEM_FONT_COLOR			(Color(255, 0, 0, 0))
#define DEF_ITEM_TEXT_MARGIN		(10)
#define DEF_ITEM_BORDER_WIDTH		(1)
#define DEF_ITEM_ICON_WIDTH			(15)
#define DEF_ITEM_ICON_HEIGHT		(15)

#define ID_BTN_LEFT_ARROW			(0x1309)
#define ID_BTN_RIGHT_ARROW			(0x130A)

#define OL_TYPE_TEXT				1
#define OL_TYPE_ICON				2

typedef struct tagOLThreadParam
{
	CWnd* pMainWnd;
	CString strIconURL;
} OLThreadParam;

class CInfoOutlinkWnd : public CWnd
{
	DECLARE_DYNAMIC(CInfoOutlinkWnd)

public:
	CInfoOutlinkWnd();
	virtual ~CInfoOutlinkWnd();

private:
	// BG
	Image*						m_pImgBG;
	Image*						m_pImgItem;
	Image*						m_pImgItemOver;
	Image*						m_pImgItemDown;
	Image*						m_pImgItemBorder;


	// dimension
	CRect						m_rtWnd;
	CRect						m_rtLeftArrow;
	CRect						m_rtRightArrow;
	CRect						m_rtItem;

	// font
	WCHAR						m_wszFontName[64];
	REAL						m_nFontHeight;
	FontStyle					m_fontStyle;
	Color						m_crText;


	// child
	CPtrArray					m_ptrArItem;
	CNMImgButton				m_btnLeftArrow;
	CNMImgButton				m_btnRightArrow;


	// tracking
	BOOL						m_bTracking;

protected:
	DECLARE_MESSAGE_MAP()

	typedef struct _outlink_item_info
	{
		int						nType;
		CString					strText;
		CString					strURL;
		CString					strIconFilePath;
		Image*					pIconImage;
		CRect					rtItem;
		CRect					rtText;
		CSize					szText;
		BOOL					bHover;
		BOOL					bDown;

		_outlink_item_info()
		{
			nType = OL_TYPE_TEXT;
			strText = _T("");
			strURL = _T("");
			strIconFilePath = _T("");
			
			pIconImage = NULL;

			rtItem.SetRectEmpty();
            rtText.SetRectEmpty();
            szText.SetSize(0, 0);
			bHover = FALSE;
			bDown = FALSE;
		}
	} OUTLINK_ITEM_INFO, *POUTLINK_ITEM_INFO;

public:
	static UINT ThreadDownloadIcon(LPVOID pParam);
	static CString GetIconFilePathFromURL(CString strURL);

	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBtnClickedLeftArrow();
	afx_msg void OnBtnClickedRightArrow();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnMouseHover(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);

	void						SetImgBGPath(CString strFileName);
	void						SetImgItemPath(CString strFileName, CString strFileNameOver, CString strFileNameClick);
	void						SetImgItemBorderPath(CString strFileName);
	void						LoadIconImage(CString strIconPath);
	void						RecalcItemInfo();
	void						UpdateBtnInfo();
	void						ScrollItemInc(int nDiff, BOOL bLeft);
	void						ScrollItem(int nScroll);
	void						SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText);
	void						ClearOutlinkItemAll();
	void						AddOutlinkItem(NE_OUTLINK_DATA &outlink);
	_outlink_item_info*			GetFirstVisibleItem(_outlink_item_info*& pOIPrior);
	_outlink_item_info*			GetLastVisibleItem(_outlink_item_info*& pOINext);
	_outlink_item_info*			AllocOutlinkItem(CString strText, CString strURL, CString strIconURL);
};
